package models

import (
	"go.mongodb.org/mongo-driver/bson"
	"go.mongodb.org/mongo-driver/mongo"
	ct "gogs.mikescher.com/BlackForestBytes/goext/cursortoken"
	"regexp"
)

type OrganizationFilter struct {
	Search          *string
	FrontendEnabled *bool
}

func (f OrganizationFilter) FilterQuery() mongo.Pipeline {
	pipeline := mongo.Pipeline{}

	pipeline = append(pipeline, bson.D{{Key: "$match", Value: bson.M{"deleted": nil}}})

	if f.FrontendEnabled != nil {
		pipeline = append(pipeline, bson.D{{Key: "$match", Value: bson.M{"frontendEnabled": *f.FrontendEnabled}}})
	}

	if f.Search != nil {
		ss := ".*" + regexp.QuoteMeta(*f.Search) + ".*"
		pipeline = append(pipeline, bson.D{{Key: "$match", Value: bson.M{"name": bson.M{"$regex": ss, "$options": "i"}}}})
	}

	return pipeline
}

func (f OrganizationFilter) Pagination() (string, ct.SortDirection, string, ct.SortDirection) {
	return "creationTime", ct.SortDESC, "_id", ct.SortDESC
}
