package models

type OrgUserPermKey string //@enum:type

const (
	OrgUserPermSuper            OrgUserPermKey = "SUPER"          // ContentProvider Administrator
	OrgUserPermLogin            OrgUserPermKey = "LOGIN"          // Kann sich einloggen
	OrgUserPermEditOrganization OrgUserPermKey = "ORG::EDIT"      // Kann ContentProvider bearbeiten
	OrgUserPermCreatePosts      OrgUserPermKey = "POSTS::CREATE"  // Kann Posts erstellen
	OrgUserPermEditPosts        OrgUserPermKey = "POSTS::EDIT"    // Kann Posts bearbeiten
	OrgUserPermDeletePosts      OrgUserPermKey = "POSTS::DELETE"  // Kann Posts löschen
	OrgUserPermCreateGroups     OrgUserPermKey = "GROUPS::CREATE" // Kann Gruppen erstellen
	OrgUserPermEditGroups       OrgUserPermKey = "GROUPS::EDIT"   // Kann Gruppen bearbeiten
	OrgUserPermDeleteGroups     OrgUserPermKey = "GROUPS::DELETE" // Kann Gruppen löschen
	OrgUserPermCreateUser       OrgUserPermKey = "USER::CREATE"   // Kann Benutzer erstellen
	OrgUserPermEditUser         OrgUserPermKey = "USER::EDIT"     // Kann Benutzer bearbeiten
	OrgUserPermDeleteUser       OrgUserPermKey = "USER::DELETE"   // Kann Benutzer löschen
	OrgUserPermCreateEvents     OrgUserPermKey = "EVENTS::CREATE" // Kann Veranstaltungen erstellen
	OrgUserPermEditEvents       OrgUserPermKey = "EVENTS::EDIT"   // Kann Veranstaltungen bearbeiten
	OrgUserPermDeleteEvents     OrgUserPermKey = "EVENTS::DELETE" // Kann Veranstaltungen löschen
)

type OrgUserPermissionList []OrgUserPermKey

func (lst OrgUserPermissionList) IsSuper() bool {
	for _, v := range lst {
		if v == OrgUserPermSuper {
			return true
		}
	}
	return false
}

func (lst OrgUserPermissionList) IsAllowed(k OrgUserPermKey) bool {
	for _, v := range lst {
		if v == k {
			return true
		}
		if v == OrgUserPermSuper {
			return true
		}
	}
	return false
}

func (lst OrgUserPermissionList) Contains(k OrgUserPermKey) bool {
	for _, v := range lst {
		if v == k {
			return true
		}
	}
	return false
}

func (lst OrgUserPermissionList) Valid() bool {
	for _, v := range lst {
		if !v.Valid() {
			return false
		}
	}
	return true
}
